﻿using System;

namespace Polecenie
{
    class Program
    {
        static void Main(string[] args)
        {
            try //powinno być wokół każdego przelewu osobno
            {
                Konto konto1 = new Konto(1, 100);
                Konto konto2 = new Konto(2, 150);

                konto1.WyświetlSaldo();
                konto2.WyświetlSaldo();

                //Konto.Przelew(konto1, konto2, 50);
                IPolecenie polecenieA = new PoleceniePrzelewu(konto1, konto2, 50);
                IPolecenie polecenieB = new PoleceniePrzelewu(konto2, konto1, 100);

                void wykonajPolecenie(IPolecenie polecenie)
                {
                    if (polecenie.CzyMożnaWykonać()) polecenie.Wykonaj();
                    else throw new Exception("Polecenie nie może być zrealizowane");
                }

                wykonajPolecenie(polecenieA);                

                konto1.WyświetlSaldo();
                konto2.WyświetlSaldo();

                //Konto.Przelew(konto2, konto1, 100);
                wykonajPolecenie(polecenieB);
                wykonajPolecenie(polecenieA);

                konto1.WyświetlSaldo();
                konto2.WyświetlSaldo();
            }
            catch (Exception exc)
            {
                Console.Error.WriteLine("Błąd: " + exc.Message);
            }
        }
    }
}
